# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

Name:           apache-pdfbox
Version:        1.6.0
Release:        1%{?dist}
Epoch:          0
Summary:        Java PDF Library
License:        Apache Software License 2.0
Url:            http://pdfbox.apache.org/
Group:          Development/Libraries
Source0:        http://www.apache.org/dist/pdfbox/1.6.0/pdfbox-1.6.0-src.zip

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        http://repo2.maven.org/maven2/com/adobe/pdf/pcfi/2010.08.09/pcfi-2010.08.09.jar

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-nodeps
BuildRequires:  junit
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-doxia
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-shared-plugin-testing-harness
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  felix-maven2
BuildRequires:  apache-rat
BuildRequires:  apache-commons-parent
BuildRequires:  apache-commons-cli
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-compress
BuildRequires:  apache-commons-io
BuildRequires:  apache-commons-lang
BuildRequires:  bouncycastle
BuildRequires:  icu4j
BuildRequires:  lucene
BuildRequires:  lucene-demo

Requires:       apache-commons-cli
Requires:       apache-commons-collections
Requires:       apache-commons-compress
Requires:       apache-commons-io
Requires:       apache-commons-lang
Requires:       icu4j
Requires:       lucene-demo

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
Apache PDFBox is an open source Java PDF library for working
with PDF documents. This project allows creation of new PDF
documents, manipulation of existing documents and the
ability to extract content from documents. Apache PDFBox
also includes several command line utilities. 
* PDF to text extraction
* Merge PDF Documents
* PDF Document Encryption/Decryption
* Lucene Search Engine Integration
* Fill in form data FDF and XFDF
* Create a PDF from a text file
* Create images from PDF pages
* Print a PDF

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n pdfbox-%{version}
# remove all binary libs
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
mkdir -p pdfbox/download
cp %{SOURCE3} pdfbox/download

mkdir -p pdfbox/target/maven-shared-archive-resources/META-INF

%build
cp %{SOURCE1} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        site javadoc:aggregate


%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-reactor.pom
%add_to_maven_depmap org.apache.pdfbox pdfbox-reactor %{version} JPP/%{name} reactor
install -m 644 parent/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.apache.pdfbox pdfbox-parent %{version} JPP/%{name} parent

install -m 644 ant/target/pdfbox-ant-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/ant-%{version}.jar
install -m 644 ant/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ant.pom
%add_to_maven_depmap org.apache.pdfbox pdfbox-ant %{version} JPP/%{name} ant

install -m 644 app/target/pdfbox-app-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/app-%{version}.jar
install -m 644 app/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-app.pom
%add_to_maven_depmap org.apache.pdfbox pdfbox-app %{version} JPP/%{name} app

install -m 644 fontbox/target/fontbox-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/fontbox-%{version}.jar
install -m 644 fontbox/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-fontbox.pom
%add_to_maven_depmap org.apache.pdfbox fontbox %{version} JPP/%{name} fontbox

install -m 644 jempbox/target/jempbox-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/jempbox-%{version}.jar
install -m 644 jempbox/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jempbox.pom
%add_to_maven_depmap org.apache.pdfbox jempbox %{version} JPP/%{name} jempbox

install -m 644 pdfbox/target/pdfbox-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/pdfbox-%{version}.jar
install -m 644 pdfbox/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pdfbox.pom
%add_to_maven_depmap org.apache.pdfbox pdfbox %{version} JPP/%{name} pdfbox

install -m 644 lucene/target/pdfbox-lucene-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/lucene-%{version}.jar
install -m 644 lucene/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-lucene.pom
%add_to_maven_depmap org.apache.pdfbox pdfbox-lucene %{version} JPP/%{name} lucene

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/war
cp -pr war/target/pdfbox-war-%{version}/* $RPM_BUILD_ROOT%{_datadir}/%{name}/war
rm $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/commons-logging-1.1.1.jar
ln -sf %{_javadir}/commons-logging.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/
rm $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/fontbox-%{version}.jar
ln -sf %{_javadir}/%{name}/fontbox.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/
rm $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/jempbox-%{version}.jar
ln -sf %{_javadir}/%{name}/jempbox.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/
rm $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/pdfbox-%{version}.jar
ln -sf %{_javadir}/%{name}/pdfbox.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/war/WEB-INF/lib/

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Mon Feb 13 2012 Ralph Apel <r.apel at r-apel.de> 0:1.6.0-1
- 1.6.0

* Sat Oct 02 2010 Ralph Apel <r.apel at r-apel.de> 0:1.2.1-1
- first JPP release

